package main

import (
	"git.swzry.com/zry/zTinyPasswd"
	"fmt"
)

func main()  {
	ztpm,err :=zTinyPasswd.NewPasswdManagerFromFileName("test.json")
	if err != nil{
		fmt.Println("Failed: ", err)
		return
	}
	ztpm.Add("root", []byte("hello,zry"), "admin")
	ztpm.Add("zry", []byte("hello,zry"), "admin")
	ztpm.Add("test1", []byte("qwertyuiop"), "user")
	ztpm.Add("test2", []byte("asdfghjkl"), "user")
	ztpm.Add("test3", []byte("zxcvbnm"), "user")
	u1r,u1e := ztpm.GetUserInfo("zry")
	fmt.Println("User zry Info:", u1r, u1e)
	fmt.Println("\nList Users @ T1:")
	ul := ztpm.ListUser()
	for i,v := range ul {
		utr,ute := ztpm.GetUserInfo(v)
		fmt.Println(i, v, utr, ute)
	}
	ztpm.ChangeRole("zry", "master")
	ztpm.ChangeExternal("test1", "ExtMsgForTest1")
	fmt.Println("\nList Users @ T2:")
	ul = ztpm.ListUser()
	for i,v := range ul {
		utr,ute := ztpm.GetUserInfo(v)
		fmt.Println(i, v, utr, ute)
	}
	ztpm.DeleteUser("test3")
	ztpm.RenameUser("test1", "etest")
	fmt.Println("\nList Users @ T3:")
	ul = ztpm.ListUser()
	for i,v := range ul {
		utr,ute := ztpm.GetUserInfo(v)
		fmt.Println(i, v, utr, ute)
	}
	ztpm.Add("hhh", []byte("??????"), "guest")
	fmt.Println("Auth Test 1:")
	suc := ztpm.Auth("zry", []byte("hello,zry"))
	if suc {
		fmt.Println("User zry Logged In.")
	}else {
		fmt.Println("User zry Auth Failed.")
	}
	fmt.Println("Auth Test 2:")
	suc = ztpm.Auth("zry", []byte("hellozry"))
	if suc {
		fmt.Println("User zry Logged In.")
	}else {
		fmt.Println("User zry Auth Failed.")
	}
	ztpm.ChangePassword("zry", []byte("hellozry"))
	fmt.Println("Auth Test 3:")
	suc = ztpm.Auth("zry", []byte("hello,zry"))
	if suc {
		fmt.Println("User zry Logged In.")
	}else {
		fmt.Println("User zry Auth Failed.")
	}
}
